Subject: bug#6998: closed (Re: 24.0.50; bidi: lines starting with neutral types have the wrong base direction?)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 10 Sep 2010 22:34:02 +0000

Your bug report

#6998: 24.0.50; bidi: lines starting with neutral types have the wrong base direction?

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
6998: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=6998
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: 24.0.50; bidi: lines starting with neutral types have the wrong base direction?
From: Thamer Mahmoud <[email-masked]>
To: [email-masked]
Date: Sat, 11 Sep 2010 01:29:44 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

I did some testing, and I found out that the differences between Emacs
and other apps (fribidi, gedit, kwrite, etc) are explained by the other
apps' use of "line-based reordering", while Emacs uses
"paragraph-based reordering" (perhaps to avoid filled paragraphs
having more than one direction). So I guess this is not a bug per se.

However, I still see inconsistent rendering of the second example
given above. But I'll file a more specific bug for that.

Closing.

-- 
Thamer

Subject: 24.0.50; bidi: lines starting with neutral types have the wrong base direction?
From: Thamer Mahmoud <[email-masked]>
To: [email-masked]
Date: Wed, 8 Sep 2010 11:39:06 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

While investigating a crash I came across this problem.

By default in Emacs, lines starting with Other Neutral types (in this
case `*') seem to be following the direction of the line before them,
and perhaps not being considered as separate paragraphs. This makes
Emacs display files differently than the output of fribidi (gedit,
etc).

For example, I have a file with the following content:

* ARABIC
* abcdef

I'd expect to see:

                             CIBARA *
* abcdef                             

But in Emacs it's shown as:

                             CIBARA *
                             abcdef *

Another example is:

* First
[BLANK_LINE]
ARABIC
* Second

What I expect:

* First
[BLANK_LINE]
                               CIBARA
* Second

What is shown in Emacs:

* First
[BLANK_LINE]
                               CIBARA
                             Second *

This seems like a bug to me.

Tests were done using -Q --eval "(setq-default bidi-display-reordering t)".
In GNU Emacs 24.0.50.6 (i686-pc-linux-gnu, GTK+ Version 2.20.1)
 of 2010-09-07

Thanks.

--
Thamer